<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>magpar: field/hexch_ani.c Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<!-- Generated by Doxygen 1.6.3 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.html"><span>Globals</span></a></li>
    </ul>
  </div>
  <div class="navpath"><a class="el" href="dir_00a13ab5e3afe633796d5c180ae90994.html">field</a>
  </div>
</div>
<div class="contents">
<h1>hexch_ani.c</h1><a href="hexch__ani_8c.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    This file is part of magpar.</span>
<a name="l00003"></a>00003 <span class="comment"></span>
<a name="l00004"></a>00004 <span class="comment">    Copyright (C) 2002-2010 Werner Scholz</span>
<a name="l00005"></a>00005 <span class="comment"></span>
<a name="l00006"></a>00006 <span class="comment">    www:   http://www.magpar.net/</span>
<a name="l00007"></a>00007 <span class="comment">    email: magpar(at)magpar.net</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">    magpar is free software; you can redistribute it and/or modify</span>
<a name="l00010"></a>00010 <span class="comment">    it under the terms of the GNU General Public License as published by</span>
<a name="l00011"></a>00011 <span class="comment">    the Free Software Foundation; either version 2 of the License, or</span>
<a name="l00012"></a>00012 <span class="comment">    (at your option) any later version.</span>
<a name="l00013"></a>00013 <span class="comment"></span>
<a name="l00014"></a>00014 <span class="comment">    magpar is distributed in the hope that it will be useful,</span>
<a name="l00015"></a>00015 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00016"></a>00016 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the</span>
<a name="l00017"></a>00017 <span class="comment">    GNU General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">    You should have received a copy of the GNU General Public License</span>
<a name="l00020"></a>00020 <span class="comment">    along with magpar; if not, write to the Free Software</span>
<a name="l00021"></a>00021 <span class="comment">    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00022"></a>00022 <span class="comment">*/</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Id[] = <span class="stringliteral">&quot;$Id: hexch_ani.c 3023 2010-03-27 23:42:04Z scholz $\n\n&quot;</span>;
<a name="l00025"></a>00025 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Td[] = <span class="stringliteral">&quot;$Today: &quot;</span> __FILE__ <span class="stringliteral">&quot;  &quot;</span> __DATE__ <span class="stringliteral">&quot;  &quot;</span>  __TIME__  <span class="stringliteral">&quot; $\n\n&quot;</span>;
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="field_8h.html">field.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="init_8h.html">init/init.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="util_8h.html">util/util.h</a>&quot;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="keyword">static</span> <span class="keywordtype">int</span>       doinit=1;
<a name="l00032"></a>00032 <span class="keyword">static</span> <span class="keywordtype">int</span>       fieldon=0;
<a name="l00033"></a>00033 
<a name="l00034"></a><a class="code" href="myllgjacobian_8c.html#a56704064cd6d4568b0172a2747dd3193">00034</a>        Mat       <a class="code" href="hexch__ani_8c.html#a56704064cd6d4568b0172a2747dd3193">Ad2E_dMidMk</a>; 
<a name="l00035"></a>00035 <span class="keyword">static</span> PetscReal Eanioffset;  
<a name="l00037"></a>00037 <span class="preprocessor">#ifdef EXCH</span>
<a name="l00038"></a>00038 <span class="preprocessor"></span><span class="keyword">static</span> Mat       AHexchonly;  
<a name="l00039"></a>00039 <span class="preprocessor">#endif</span>
<a name="l00040"></a>00040 <span class="preprocessor"></span>
<a name="l00041"></a><a class="code" href="hexch__ani_8c.html#ae33fb5e4bf8cbe9e2361e84f29a77d35">00041</a> <span class="preprocessor">#define PREALLOC_DG 15</span>
<a name="l00042"></a><a class="code" href="hexch__ani_8c.html#a466793c34bde5662dfab48310c5c42e2">00042</a> <span class="preprocessor"></span><span class="preprocessor">#define PREALLOC_OD 5</span>
<a name="l00043"></a>00043 <span class="preprocessor"></span>
<a name="l00044"></a><a class="code" href="hexch__ani_8c.html#a9db4f6f0ac5776543bcd4f802226942e">00044</a> <span class="keywordtype">int</span> <a class="code" href="hexch__ani_8c.html#a9db4f6f0ac5776543bcd4f802226942e">Hexchani_Init</a>(<a class="code" href="structGridData.html">GridData</a> *gdata)
<a name="l00045"></a>00045 {
<a name="l00046"></a>00046   <a class="code" href="griddata_8h.html#a3d9da926137619fd02adb245a08536c7">MagparFunctionLogBegin</a>;
<a name="l00047"></a>00047 
<a name="l00048"></a>00048   <span class="keywordtype">int</span> rank,size;
<a name="l00049"></a>00049   ierr = MPI_Comm_size(PETSC_COMM_WORLD,&amp;size);CHKERRQ(ierr);
<a name="l00050"></a>00050   ierr = MPI_Comm_rank(PETSC_COMM_WORLD,&amp;rank);CHKERRQ(ierr);
<a name="l00051"></a>00051 
<a name="l00052"></a>00052   fieldon=0;
<a name="l00053"></a>00053 
<a name="l00054"></a>00054   <a class="code" href="hexch__ani_8c.html#a56704064cd6d4568b0172a2747dd3193">Ad2E_dMidMk</a>=PETSC_NULL;
<a name="l00055"></a>00055   <span class="comment">/* create gdata-&gt;VHexchani in any case</span>
<a name="l00056"></a>00056 <span class="comment">     otherwise we get SEGV in WriteAVS</span>
<a name="l00057"></a>00057 <span class="comment">     TODO: not most elegant way to solve this issue</span>
<a name="l00058"></a>00058 <span class="comment">  */</span>
<a name="l00059"></a>00059   ierr = VecDuplicate(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,&amp;gdata-&gt;<a class="code" href="structGridData.html#a17f878ef23cf508f086e5d1958657e3f">VHexchani</a>);CHKERRQ(ierr);
<a name="l00060"></a>00060 
<a name="l00061"></a>00061   <span class="comment">/* activate only if Ms&gt;0 &amp;&amp; (K1!=0 or A!=0) */</span>
<a name="l00062"></a>00062   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;gdata-&gt;<a class="code" href="structGridData.html#a4c7b7cea771dca3b63a4a37b0666ffc5">n_prop</a>;i++) {
<a name="l00063"></a>00063     <span class="keywordflow">if</span> (gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*i+4]&gt;0.0 &amp;&amp; (gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*i+2]!=0.0 || gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*i+5]!=0.0)) {
<a name="l00064"></a>00064       fieldon=1;
<a name="l00065"></a>00065       <span class="keywordflow">break</span>;
<a name="l00066"></a>00066     }
<a name="l00067"></a>00067   }
<a name="l00068"></a>00068   <span class="keywordflow">if</span> (!fieldon) {
<a name="l00069"></a>00069     PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Hexchani off\n&quot;</span>);
<a name="l00070"></a>00070     ierr = PetscOptionsSetValue(<span class="stringliteral">&quot;-precon&quot;</span>,<span class="stringliteral">&quot;0&quot;</span>);CHKERRQ(ierr);
<a name="l00071"></a>00071     PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Disabling preconditioning\n&quot;</span>);
<a name="l00072"></a>00072 
<a name="l00073"></a>00073     gdata-&gt;<a class="code" href="structGridData.html#a17f878ef23cf508f086e5d1958657e3f">VHexchani</a>=PETSC_NULL;
<a name="l00074"></a>00074 <span class="preprocessor">#ifdef EXCH</span>
<a name="l00075"></a>00075 <span class="preprocessor"></span>    gdata-&gt;VHexchonly=PETSC_NULL;
<a name="l00076"></a>00076 <span class="preprocessor">#endif</span>
<a name="l00077"></a>00077 <span class="preprocessor"></span>
<a name="l00078"></a>00078     <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00079"></a>00079   }
<a name="l00080"></a>00080   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Hexchani on\n&quot;</span>);
<a name="l00081"></a>00081 
<a name="l00082"></a>00082   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Calculating sparsity pattern for matrix preallocation\n&quot;</span>);
<a name="l00083"></a>00083 
<a name="l00084"></a>00084   <span class="comment">/* get ownership range */</span>
<a name="l00085"></a>00085   <span class="keywordtype">int</span> low,high;
<a name="l00086"></a>00086   ierr = VecGetOwnershipRange(gdata-&gt;<a class="code" href="structGridData.html#a6415aba4002f4be8541f8f1ee7b9391d">elevol</a>,&amp;low,&amp;high);CHKERRQ(ierr);
<a name="l00087"></a>00087 
<a name="l00088"></a>00088   <span class="keywordtype">int</span> *elevertall;
<a name="l00089"></a>00089 
<a name="l00090"></a>00090 <span class="preprocessor">#ifdef HAVE_ELEVERTALL</span>
<a name="l00091"></a>00091 <span class="preprocessor"></span>  elevertall=gdata-&gt;elevertall;
<a name="l00092"></a>00092 <span class="preprocessor">#else</span>
<a name="l00093"></a>00093 <span class="preprocessor"></span>  <span class="keywordflow">if</span> (size&gt;1) {
<a name="l00094"></a>00094     ierr = PetscMalloc(<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>*gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>*<span class="keyword">sizeof</span>(<span class="keywordtype">int</span>),&amp;elevertall);CHKERRQ(ierr);
<a name="l00095"></a>00095     ierr = PetscMemcpy(elevertall+<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>*low,gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>,<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>*gdata-&gt;<a class="code" href="structGridData.html#aa69a0b0a497df4cbeee604d3de4ff0b1">ln_ele</a>*<span class="keyword">sizeof</span>(<span class="keywordtype">int</span>));CHKERRQ(ierr);
<a name="l00096"></a>00096 
<a name="l00097"></a>00097     <span class="keywordtype">int</span> *p;
<a name="l00098"></a>00098     p=elevertall;
<a name="l00099"></a>00099 
<a name="l00100"></a>00100     <span class="keywordtype">int</span> recvcount[size];
<a name="l00101"></a>00101     recvcount[rank]=<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>*gdata-&gt;<a class="code" href="structGridData.html#aa69a0b0a497df4cbeee604d3de4ff0b1">ln_ele</a>;
<a name="l00102"></a>00102     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;size;i++) {
<a name="l00103"></a>00103       ierr = MPI_Bcast(recvcount+i,1,MPI_INT,i,PETSC_COMM_WORLD);CHKERRQ(ierr);
<a name="l00104"></a>00104       <span class="comment">/* we could also use MPI_Send/Recv to get everything just to the first processor */</span>
<a name="l00105"></a>00105       ierr = MPI_Bcast(p,recvcount[i],MPI_INT,i,PETSC_COMM_WORLD);CHKERRQ(ierr);
<a name="l00106"></a>00106       p+=recvcount[i];
<a name="l00107"></a>00107     }
<a name="l00108"></a>00108     assert(p==elevertall+<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>*gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>);
<a name="l00109"></a>00109   }
<a name="l00110"></a>00110   <span class="keywordflow">else</span> {
<a name="l00111"></a>00111     elevertall=gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>;
<a name="l00112"></a>00112   }
<a name="l00113"></a>00113 <span class="preprocessor">#endif</span>
<a name="l00114"></a>00114 <span class="preprocessor"></span>
<a name="l00115"></a>00115   <span class="keywordtype">int</span> *ia,*ja;
<a name="l00116"></a>00116 <span class="preprocessor">#ifdef HAVE_M2IJ</span>
<a name="l00117"></a>00117 <span class="preprocessor"></span>  ia=gdata-&gt;mesh2nodal_ia;
<a name="l00118"></a>00118   ja=gdata-&gt;mesh2nodal_ja;
<a name="l00119"></a>00119 <span class="preprocessor">#else</span>
<a name="l00120"></a>00120 <span class="preprocessor"></span>  ierr = <a class="code" href="mesh2dual_8c.html#abb99aec57817a85ad1c4c2552f695434">Mesh2Nodal</a>(gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>,gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>,elevertall,&amp;ia,&amp;ja);CHKERRQ(ierr);
<a name="l00121"></a>00121 <span class="preprocessor">#endif</span>
<a name="l00122"></a>00122 <span class="preprocessor"></span>
<a name="l00123"></a>00123   <span class="comment">/* get ownership range */</span>
<a name="l00124"></a>00124   ierr = VecGetOwnershipRange(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,&amp;low,&amp;high);CHKERRQ(ierr);
<a name="l00125"></a>00125   low/=<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>;
<a name="l00126"></a>00126   high/=<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>;
<a name="l00127"></a>00127 
<a name="l00128"></a>00128   <span class="keywordtype">int</span> *d_nnz;
<a name="l00129"></a>00129   <span class="keywordtype">int</span> *o_nnz;
<a name="l00130"></a>00130   ierr = PetscMalloc(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*(high-low)*<span class="keyword">sizeof</span>(<span class="keywordtype">int</span>),&amp;d_nnz);CHKERRQ(ierr);
<a name="l00131"></a>00131   ierr = PetscMalloc(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*(high-low)*<span class="keyword">sizeof</span>(<span class="keywordtype">int</span>),&amp;o_nnz);CHKERRQ(ierr);
<a name="l00132"></a>00132   <span class="comment">/* calculate number of nonzeroes for each line */</span>
<a name="l00133"></a>00133   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=low;i&lt;high;i++) {
<a name="l00134"></a>00134     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> j=0;j&lt;<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>;j++) {
<a name="l00135"></a>00135       d_nnz[ND*(i-low)+j]=ND;
<a name="l00136"></a>00136       o_nnz[ND*(i-low)+j]=0;
<a name="l00137"></a>00137       <span class="keywordflow">for</span> (<span class="keywordtype">int</span> l=ia[i];l&lt;ia[i+1];l++) {
<a name="l00138"></a>00138         <span class="keywordflow">if</span> (ja[l]&gt;=low &amp;&amp; ja[l]&lt;high) {
<a name="l00139"></a>00139           d_nnz[ND*(i-low)+j]+=ND;
<a name="l00140"></a>00140         }
<a name="l00141"></a>00141         <span class="keywordflow">else</span> {
<a name="l00142"></a>00142           o_nnz[ND*(i-low)+j]+=ND;
<a name="l00143"></a>00143         }
<a name="l00144"></a>00144       }
<a name="l00145"></a>00145     }
<a name="l00146"></a>00146   }
<a name="l00147"></a>00147 
<a name="l00148"></a>00148   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Creating matrices\n&quot;</span>);
<a name="l00149"></a>00149   <span class="comment">/* create matrix to calculate Ad2E_dMidMk */</span>
<a name="l00150"></a>00150 <span class="comment">/* normal MPIAIJ format: */</span>
<a name="l00151"></a>00151   ierr = MatCreateMPIAIJ(
<a name="l00152"></a>00152     PETSC_COMM_WORLD,
<a name="l00153"></a>00153     <a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*gdata-&gt;<a class="code" href="structGridData.html#ae08e5326571671a361ae5d761d6ca672">ln_vert</a>,<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*gdata-&gt;<a class="code" href="structGridData.html#ae08e5326571671a361ae5d761d6ca672">ln_vert</a>,
<a name="l00154"></a>00154     <a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>,<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>,
<a name="l00155"></a>00155     0,d_nnz,0,o_nnz,
<a name="l00156"></a>00156     &amp;<a class="code" href="hexch__ani_8c.html#a56704064cd6d4568b0172a2747dd3193">Ad2E_dMidMk</a>
<a name="l00157"></a>00157   );CHKERRQ(ierr);
<a name="l00158"></a>00158   ierr = MatSetFromOptions(<a class="code" href="hexch__ani_8c.html#a56704064cd6d4568b0172a2747dd3193">Ad2E_dMidMk</a>);CHKERRQ(ierr);
<a name="l00159"></a>00159 <span class="comment">/* block MPIAIJ format:</span>
<a name="l00160"></a>00160 <span class="comment">  ierr = MatCreateMPIBAIJ(</span>
<a name="l00161"></a>00161 <span class="comment">    PETSC_COMM_WORLD,</span>
<a name="l00162"></a>00162 <span class="comment">    ND,</span>
<a name="l00163"></a>00163 <span class="comment">    ND*gdata-&gt;ln_vert,ND*gdata-&gt;ln_vert,</span>
<a name="l00164"></a>00164 <span class="comment">    ND*gdata-&gt;n_vert,ND*gdata-&gt;n_vert,</span>
<a name="l00165"></a>00165 <span class="comment">    PREALLOC_DG,PETSC_NULL,PREALLOC_OD,PETSC_NULL,</span>
<a name="l00166"></a>00166 <span class="comment">    &amp;Ad2E_dMidMk</span>
<a name="l00167"></a>00167 <span class="comment">  );CHKERRQ(ierr);</span>
<a name="l00168"></a>00168 <span class="comment">  ierr = MatSetFromOptions(Ad2E_dMidMk);CHKERRQ(ierr);</span>
<a name="l00169"></a>00169 <span class="comment">*/</span>
<a name="l00170"></a>00170 
<a name="l00171"></a>00171 <span class="preprocessor">#ifdef EXCH</span>
<a name="l00172"></a>00172 <span class="preprocessor"></span>  <span class="comment">/* calculate number of nonzeroes for each line */</span>
<a name="l00173"></a>00173   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=low;i&lt;high;i++) {
<a name="l00174"></a>00174     <span class="keywordtype">int</span> k;
<a name="l00175"></a>00175     k=ia[i+1]-ia[i]+1;
<a name="l00176"></a>00176     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> j=0;j&lt;<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>;j++) {
<a name="l00177"></a>00177       <span class="keywordflow">if</span> (i&gt;=low || i&lt;high) {
<a name="l00178"></a>00178         d_nnz[ND*(i-low)+j]=k;
<a name="l00179"></a>00179       }
<a name="l00180"></a>00180       <span class="keywordflow">else</span> {
<a name="l00181"></a>00181         o_nnz[ND*(i-low)+j]=k;
<a name="l00182"></a>00182       }
<a name="l00183"></a>00183     }
<a name="l00184"></a>00184   }
<a name="l00185"></a>00185 
<a name="l00186"></a>00186   <span class="comment">/* matrix for exchange field */</span>
<a name="l00187"></a>00187   ierr = MatCreateMPIAIJ(
<a name="l00188"></a>00188     PETSC_COMM_WORLD,
<a name="l00189"></a>00189     <a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*gdata-&gt;<a class="code" href="structGridData.html#ae08e5326571671a361ae5d761d6ca672">ln_vert</a>,<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*gdata-&gt;<a class="code" href="structGridData.html#ae08e5326571671a361ae5d761d6ca672">ln_vert</a>,
<a name="l00190"></a>00190     <a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>,<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>,
<a name="l00191"></a>00191     0,d_nnz,0,o_nnz,
<a name="l00192"></a>00192     &amp;AHexchonly
<a name="l00193"></a>00193   );CHKERRQ(ierr);
<a name="l00194"></a>00194   ierr = MatSetFromOptions(AHexchonly);CHKERRQ(ierr);
<a name="l00195"></a>00195 
<a name="l00196"></a>00196   ierr = VecDuplicate(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,&amp;gdata-&gt;VHexchonly);CHKERRQ(ierr);
<a name="l00197"></a>00197 <span class="preprocessor">#endif</span>
<a name="l00198"></a>00198 <span class="preprocessor"></span>
<a name="l00199"></a>00199 <span class="preprocessor">#ifndef HAVE_M2IJ</span>
<a name="l00200"></a>00200 <span class="preprocessor"></span>  ierr = PetscFree(ia);CHKERRQ(ierr);
<a name="l00201"></a>00201   ierr = PetscFree(ja);CHKERRQ(ierr);
<a name="l00202"></a>00202 <span class="preprocessor">#endif</span>
<a name="l00203"></a>00203 <span class="preprocessor"></span>  ierr = PetscFree(d_nnz);CHKERRQ(ierr);
<a name="l00204"></a>00204   ierr = PetscFree(o_nnz);CHKERRQ(ierr);
<a name="l00205"></a>00205 <span class="preprocessor">#ifndef HAVE_ELEVERTALL</span>
<a name="l00206"></a>00206 <span class="preprocessor"></span>  <span class="keywordflow">if</span> (size&gt;1) {
<a name="l00207"></a>00207     ierr = PetscFree(elevertall);CHKERRQ(ierr);
<a name="l00208"></a>00208   }
<a name="l00209"></a>00209 <span class="preprocessor">#endif</span>
<a name="l00210"></a>00210 <span class="preprocessor"></span>
<a name="l00211"></a>00211   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Calculating matrix elements\n&quot;</span>);
<a name="l00212"></a>00212 
<a name="l00213"></a>00213   PetscReal *ta_elevol;
<a name="l00214"></a>00214   ierr = VecGetArray(gdata-&gt;<a class="code" href="structGridData.html#a6415aba4002f4be8541f8f1ee7b9391d">elevol</a>,&amp;ta_elevol);CHKERRQ(ierr);
<a name="l00215"></a>00215 
<a name="l00216"></a>00216   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0; i&lt;gdata-&gt;<a class="code" href="structGridData.html#aa69a0b0a497df4cbeee604d3de4ff0b1">ln_ele</a>; i++) {
<a name="l00217"></a>00217     <span class="comment">/* skip elements with Ms&lt;=0 */</span>
<a name="l00218"></a>00218     <span class="keywordflow">if</span> (gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*gdata-&gt;<a class="code" href="structGridData.html#add8d275e857e24934b4873e5746e49b1">eleprop</a>[i]+4]&lt;=0.0) {
<a name="l00219"></a>00219       <span class="keywordflow">continue</span>;
<a name="l00220"></a>00220     }
<a name="l00221"></a>00221 
<a name="l00222"></a>00222     <span class="comment">/* get element volume */</span>
<a name="l00223"></a>00223     PetscReal t_elevol;
<a name="l00224"></a>00224     t_elevol=ta_elevol[i];
<a name="l00225"></a>00225 
<a name="l00226"></a>00226     <span class="comment">/* get vertex ids */</span>
<a name="l00227"></a>00227     <span class="keywordtype">int</span> *t_v;
<a name="l00228"></a>00228     t_v=gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>+i*<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>;
<a name="l00229"></a>00229 
<a name="l00230"></a>00230     <span class="comment">/* Get Vertex coordinates */</span>
<a name="l00231"></a>00231     PetscReal *x1,*x2,*x3,*x4;
<a name="l00232"></a>00232     x1=gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>+(t_v[0])*<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>;
<a name="l00233"></a>00233     x2=gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>+(t_v[1])*<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>;
<a name="l00234"></a>00234     x3=gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>+(t_v[2])*<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>;
<a name="l00235"></a>00235     x4=gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>+(t_v[3])*<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>;
<a name="l00236"></a>00236 
<a name="l00237"></a>00237     PetscReal D_etaj[NV][<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>];
<a name="l00238"></a>00238     <a class="code" href="elevertvol_8c.html#add57a81e67724a47fc306e81ccec2a5e">tetgrad</a>(x1,x2,x3,x4,D_etaj);
<a name="l00239"></a>00239 
<a name="l00240"></a>00240     <span class="comment">/* set matrix elements */</span>
<a name="l00241"></a>00241 
<a name="l00242"></a>00242     <span class="comment">/* prefactor for exchange field: pre_exch=2*A */</span>
<a name="l00243"></a>00243     PetscReal   pre_exch;
<a name="l00244"></a>00244     pre_exch=2.0*gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*gdata-&gt;<a class="code" href="structGridData.html#add8d275e857e24934b4873e5746e49b1">eleprop</a>[i]+5];
<a name="l00245"></a>00245 <span class="comment">/* must not divide by Js to account for different materials:</span>
<a name="l00246"></a>00246 <span class="comment">   |M|=1 -&gt; Js has to be considered in local fields !!!</span>
<a name="l00247"></a>00247 <span class="comment">      /gdata-&gt;propdat[NP*gdata-&gt;eleprop[i]+4];</span>
<a name="l00248"></a>00248 <span class="comment">*/</span>
<a name="l00249"></a>00249     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> l=0;l&lt;NV;l++) {
<a name="l00250"></a>00250       <span class="keywordflow">for</span> (<span class="keywordtype">int</span> j=0;j&lt;NV;j++) {
<a name="l00251"></a>00251         PetscReal matele;
<a name="l00252"></a>00252 
<a name="l00253"></a>00253         <span class="comment">/* set matrix element for jacobian */</span>
<a name="l00254"></a>00254         matele=-t_elevol*<a class="code" href="griddata_8h.html#a021d4b2692fbdc52fc1fa201b4e17c99">my_ddot</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,D_etaj[j],1,D_etaj[l],1)*pre_exch;
<a name="l00255"></a>00255         <span class="keywordflow">if</span> (PetscAbsReal(matele)&gt;<a class="code" href="griddata_8h.html#a26ab586dda1b8c780aa849e457c0cbad">D_EPS</a>) {
<a name="l00256"></a>00256           <span class="keywordflow">for</span> (<span class="keywordtype">int</span> k=0;k&lt;<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>;k++) {
<a name="l00257"></a>00257             ierr = MatSetValue(
<a name="l00258"></a>00258               <a class="code" href="hexch__ani_8c.html#a56704064cd6d4568b0172a2747dd3193">Ad2E_dMidMk</a>,
<a name="l00259"></a>00259               ND*t_v[j]+k,
<a name="l00260"></a>00260               ND*t_v[l]+k,
<a name="l00261"></a>00261               matele,
<a name="l00262"></a>00262               ADD_VALUES
<a name="l00263"></a>00263             );CHKERRQ(ierr);
<a name="l00264"></a>00264 <span class="preprocessor">#ifdef EXCH</span>
<a name="l00265"></a>00265 <span class="preprocessor"></span>            ierr = MatSetValue(
<a name="l00266"></a>00266               AHexchonly,
<a name="l00267"></a>00267               ND*t_v[j]+k,
<a name="l00268"></a>00268               ND*t_v[l]+k,
<a name="l00269"></a>00269               matele,
<a name="l00270"></a>00270               ADD_VALUES
<a name="l00271"></a>00271             );CHKERRQ(ierr);
<a name="l00272"></a>00272 <span class="preprocessor">#endif</span>
<a name="l00273"></a>00273 <span class="preprocessor"></span>          }
<a name="l00274"></a>00274         }
<a name="l00275"></a>00275       }
<a name="l00276"></a>00276     }
<a name="l00277"></a>00277   }
<a name="l00278"></a>00278 
<a name="l00279"></a>00279   ierr = MatAssemblyBegin(<a class="code" href="hexch__ani_8c.html#a56704064cd6d4568b0172a2747dd3193">Ad2E_dMidMk</a>,MAT_FLUSH_ASSEMBLY);CHKERRQ(ierr);
<a name="l00280"></a>00280   ierr = MatAssemblyEnd(<a class="code" href="hexch__ani_8c.html#a56704064cd6d4568b0172a2747dd3193">Ad2E_dMidMk</a>,MAT_FLUSH_ASSEMBLY);CHKERRQ(ierr);
<a name="l00281"></a>00281 
<a name="l00282"></a>00282 <span class="preprocessor">#ifdef EXCH</span>
<a name="l00283"></a>00283 <span class="preprocessor"></span>  ierr = MatAssemblyBegin(AHexchonly,MAT_FLUSH_ASSEMBLY);CHKERRQ(ierr);
<a name="l00284"></a>00284   ierr = MatAssemblyEnd(AHexchonly,MAT_FLUSH_ASSEMBLY);CHKERRQ(ierr);
<a name="l00285"></a>00285 <span class="preprocessor">#endif</span>
<a name="l00286"></a>00286 <span class="preprocessor"></span>
<a name="l00287"></a>00287   ierr = PetscGetTime(&amp;t_t2);CHKERRQ(ierr);
<a name="l00288"></a>00288   PetscPrintf(PETSC_COMM_WORLD,
<a name="l00289"></a>00289     <span class="stringliteral">&quot;exchange matrix calculation took %g s = %g min\n&quot;</span>,
<a name="l00290"></a>00290     t_t2-t_t1,
<a name="l00291"></a>00291     (t_t2-t_t1)/60.0
<a name="l00292"></a>00292   );
<a name="l00293"></a>00293 
<a name="l00294"></a>00294 
<a name="l00295"></a>00295   Eanioffset = 0.0;
<a name="l00296"></a>00296 
<a name="l00297"></a>00297   PetscReal   pre_ani;
<a name="l00298"></a>00298   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;gdata-&gt;<a class="code" href="structGridData.html#aa69a0b0a497df4cbeee604d3de4ff0b1">ln_ele</a>;i++) {
<a name="l00299"></a>00299     <span class="comment">/* skip elements with Ms&lt;=0 */</span>
<a name="l00300"></a>00300     <span class="keywordflow">if</span> (gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*gdata-&gt;<a class="code" href="structGridData.html#add8d275e857e24934b4873e5746e49b1">eleprop</a>[i]+4]&lt;=0.0) {
<a name="l00301"></a>00301       <span class="keywordflow">continue</span>;
<a name="l00302"></a>00302     }
<a name="l00303"></a>00303     <span class="comment">/* skip elements with K1==0 */</span>
<a name="l00304"></a>00304     <span class="keywordflow">if</span> (PetscAbsReal(gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*gdata-&gt;<a class="code" href="structGridData.html#add8d275e857e24934b4873e5746e49b1">eleprop</a>[i]+2])&lt;<a class="code" href="griddata_8h.html#a26ab586dda1b8c780aa849e457c0cbad">D_EPS</a>) {
<a name="l00305"></a>00305       <span class="keywordflow">continue</span>;
<a name="l00306"></a>00306     }
<a name="l00307"></a>00307     <span class="comment">/* skip matrix element if material has cubic anisotropy */</span>
<a name="l00308"></a>00308     <span class="keywordflow">if</span> (gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*gdata-&gt;<a class="code" href="structGridData.html#add8d275e857e24934b4873e5746e49b1">eleprop</a>[i]+16]) {
<a name="l00309"></a>00309       <span class="keywordflow">continue</span>;
<a name="l00310"></a>00310     }
<a name="l00311"></a>00311 
<a name="l00312"></a>00312     <span class="comment">/* prefactor for anisotropy field: pre_ani=2*K1*V */</span>
<a name="l00313"></a>00313     pre_ani=2.0*ta_elevol[i]*gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*gdata-&gt;<a class="code" href="structGridData.html#add8d275e857e24934b4873e5746e49b1">eleprop</a>[i]+2];
<a name="l00314"></a>00314     <span class="comment">/* division by Js to account for different materials done below (vertMomrec3) */</span>
<a name="l00315"></a>00315 
<a name="l00316"></a>00316     Eanioffset += pre_ani/2.0;
<a name="l00317"></a>00317 
<a name="l00318"></a>00318     <span class="comment">/* TODO: more elegant with MatSetValuesLocal !? */</span>
<a name="l00319"></a>00319     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> k=0;k&lt;<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>;k++) {
<a name="l00320"></a>00320       <span class="keywordflow">for</span> (<span class="keywordtype">int</span> l=0;l&lt;ND;l++) {
<a name="l00321"></a>00321         PetscReal matele;
<a name="l00322"></a>00322 
<a name="l00323"></a>00323         matele=
<a name="l00324"></a>00324           pre_ani*
<a name="l00325"></a>00325           gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*gdata-&gt;<a class="code" href="structGridData.html#add8d275e857e24934b4873e5746e49b1">eleprop</a>[i]+6+k]*
<a name="l00326"></a>00326           gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*gdata-&gt;<a class="code" href="structGridData.html#add8d275e857e24934b4873e5746e49b1">eleprop</a>[i]+6+l];
<a name="l00327"></a>00327 
<a name="l00328"></a>00328         <span class="keywordflow">if</span> (PetscAbsReal(matele)&lt;<a class="code" href="griddata_8h.html#a26ab586dda1b8c780aa849e457c0cbad">D_EPS</a>) <span class="keywordflow">continue</span>;
<a name="l00329"></a>00329 
<a name="l00330"></a>00330         <span class="keywordflow">for</span> (<span class="keywordtype">int</span> m=0;m&lt;<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>;m++) {
<a name="l00331"></a>00331           <span class="comment">/* calculate Int(phi[i]*phi[j])</span>
<a name="l00332"></a>00332 <span class="comment"></span>
<a name="l00333"></a>00333 <span class="comment">             i==j ? Int(phi[i]*phi[j])=V/10 : Int(phi[i]*phi[j])=V/20</span>
<a name="l00334"></a>00334 <span class="comment">             source: Advanced Finite Element Methods (ASEN 6367) - Spring 2009</span>
<a name="l00335"></a>00335 <span class="comment">                     Aerospace Engineering Sciences - University of Colorado at Boulder</span>
<a name="l00336"></a>00336 <span class="comment">                     Chapter 16: THE LINEAR TETRAHEDRON</span>
<a name="l00337"></a>00337 <span class="comment">                     page 10, Eq. (16.35)</span>
<a name="l00338"></a>00338 <span class="comment">                     http://www.colorado.edu/engineering/cas/courses.d/AFEM.d/AFEM.Ch16.d/AFEM.Ch16.pdf</span>
<a name="l00339"></a>00339 <span class="comment"></span>
<a name="l00340"></a>00340 <span class="comment">                     http://smirnov.mae.wvu.edu/hedra/poisson.pdf</span>
<a name="l00341"></a>00341 <span class="comment"></span>
<a name="l00342"></a>00342 <span class="comment">                     Wenjie Chen, D. R. Fredkin, and T. R. Koehler,</span>
<a name="l00343"></a>00343 <span class="comment">                     &quot;A New Finite Element Method in Micromagnetics,&quot;</span>
<a name="l00344"></a>00344 <span class="comment">                     IEEE Trans. Magn. 29 (1993) 2124.</span>
<a name="l00345"></a>00345 <span class="comment">                     http://ieeexplore.ieee.org/iel1/20/5774/00221033.pdf</span>
<a name="l00346"></a>00346 <span class="comment"></span>
<a name="l00347"></a>00347 <span class="comment">                     see also hdemag.c</span>
<a name="l00348"></a>00348 <span class="comment">          */</span>
<a name="l00349"></a>00349           <span class="keywordflow">for</span> (<span class="keywordtype">int</span> j=0;j&lt;NV;j++) {
<a name="l00350"></a>00350             PetscReal matele2;
<a name="l00351"></a>00351 
<a name="l00352"></a>00352             <span class="keywordflow">if</span> (j==m) {
<a name="l00353"></a>00353               matele2=matele/10.0;
<a name="l00354"></a>00354             }
<a name="l00355"></a>00355             <span class="keywordflow">else</span> {
<a name="l00356"></a>00356               matele2=matele/20.0;
<a name="l00357"></a>00357             }
<a name="l00358"></a>00358 
<a name="l00359"></a>00359             ierr = MatSetValue(
<a name="l00360"></a>00360               <a class="code" href="hexch__ani_8c.html#a56704064cd6d4568b0172a2747dd3193">Ad2E_dMidMk</a>,
<a name="l00361"></a>00361               gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>[NV*i+j]*ND+k,
<a name="l00362"></a>00362               gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>[NV*i+m]*ND+l,
<a name="l00363"></a>00363               matele2,
<a name="l00364"></a>00364               ADD_VALUES
<a name="l00365"></a>00365             );CHKERRQ(ierr);
<a name="l00366"></a>00366           }
<a name="l00367"></a>00367         }
<a name="l00368"></a>00368       }
<a name="l00369"></a>00369     }
<a name="l00370"></a>00370   }
<a name="l00371"></a>00371 
<a name="l00372"></a>00372   ierr = MatAssemblyBegin(<a class="code" href="hexch__ani_8c.html#a56704064cd6d4568b0172a2747dd3193">Ad2E_dMidMk</a>,MAT_FLUSH_ASSEMBLY);CHKERRQ(ierr);
<a name="l00373"></a>00373   ierr = MatAssemblyEnd(<a class="code" href="hexch__ani_8c.html#a56704064cd6d4568b0172a2747dd3193">Ad2E_dMidMk</a>,MAT_FLUSH_ASSEMBLY);CHKERRQ(ierr);
<a name="l00374"></a>00374 
<a name="l00375"></a>00375   PetscLogDouble t_t3;
<a name="l00376"></a>00376   ierr = PetscGetTime(&amp;t_t3);CHKERRQ(ierr);
<a name="l00377"></a>00377   PetscPrintf(PETSC_COMM_WORLD,
<a name="l00378"></a>00378     <span class="stringliteral">&quot;anisotropy matrix calculation took %g s = %g min\n&quot;</span>,
<a name="l00379"></a>00379     t_t3-t_t2,
<a name="l00380"></a>00380     (t_t3-t_t2)/60.0
<a name="l00381"></a>00381   );
<a name="l00382"></a>00382 
<a name="l00383"></a>00383   ierr = VecRestoreArray(gdata-&gt;<a class="code" href="structGridData.html#a6415aba4002f4be8541f8f1ee7b9391d">elevol</a>,&amp;ta_elevol);CHKERRQ(ierr);
<a name="l00384"></a>00384 
<a name="l00385"></a>00385   PetscReal tmp;
<a name="l00386"></a>00386   ierr = PetscGlobalSum(&amp;Eanioffset,&amp;tmp,PETSC_COMM_WORLD);CHKERRQ(ierr);
<a name="l00387"></a>00387   Eanioffset=tmp;
<a name="l00388"></a>00388 
<a name="l00389"></a>00389   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Eanioffset: %g = %g J = %g J/m^3\n&quot;</span>,
<a name="l00390"></a>00390     Eanioffset,
<a name="l00391"></a>00391     Eanioffset*gdata-&gt;<a class="code" href="structGridData.html#af5ca6e17784da000ea45ebb5f65ebd03">escale</a>,
<a name="l00392"></a>00392     Eanioffset*gdata-&gt;<a class="code" href="structGridData.html#af5ca6e17784da000ea45ebb5f65ebd03">escale</a>/gdata-&gt;<a class="code" href="structGridData.html#a0ced0eaa5cb25c25363907973c7e69d6">totvol</a>
<a name="l00393"></a>00393   );
<a name="l00394"></a>00394 
<a name="l00395"></a>00395   Vec vertMomrec3;
<a name="l00396"></a>00396   ierr = VecDuplicate(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,&amp;vertMomrec3);CHKERRQ(ierr);
<a name="l00397"></a>00397   ierr = VecCopy(gdata-&gt;<a class="code" href="structGridData.html#ac9ae4905283e303be4794e8f222086cb">VMs3</a>,vertMomrec3);CHKERRQ(ierr);
<a name="l00398"></a>00398   ierr = VecReciprocal(vertMomrec3);CHKERRQ(ierr);
<a name="l00399"></a>00399 
<a name="l00400"></a>00400   PetscInfo(0,<span class="stringliteral">&quot;Ad2E_dMidMk matrix assembly complete\n&quot;</span>);
<a name="l00401"></a>00401   ierr = MatAssemblyBegin(<a class="code" href="hexch__ani_8c.html#a56704064cd6d4568b0172a2747dd3193">Ad2E_dMidMk</a>,MAT_FINAL_ASSEMBLY);CHKERRQ(ierr);
<a name="l00402"></a>00402   ierr = MatAssemblyEnd(<a class="code" href="hexch__ani_8c.html#a56704064cd6d4568b0172a2747dd3193">Ad2E_dMidMk</a>,MAT_FINAL_ASSEMBLY);CHKERRQ(ierr);
<a name="l00403"></a>00403 
<a name="l00404"></a>00404   ierr = MatDiagonalScale(<a class="code" href="hexch__ani_8c.html#a56704064cd6d4568b0172a2747dd3193">Ad2E_dMidMk</a>,vertMomrec3,PETSC_NULL);CHKERRQ(ierr);
<a name="l00405"></a>00405   ierr = <a class="code" href="printmatinfo_8c.html#a8c62a6053be02438e1bf2da1efa06f1f">PrintMatInfoAll</a>(<a class="code" href="hexch__ani_8c.html#a56704064cd6d4568b0172a2747dd3193">Ad2E_dMidMk</a>);CHKERRQ(ierr);
<a name="l00406"></a>00406 
<a name="l00407"></a>00407 <span class="preprocessor">#ifdef EXCH</span>
<a name="l00408"></a>00408 <span class="preprocessor"></span>  PetscInfo(0,<span class="stringliteral">&quot;AHexchonly matrix assembly complete\n&quot;</span>);
<a name="l00409"></a>00409   ierr = MatAssemblyBegin(AHexchonly,MAT_FINAL_ASSEMBLY);CHKERRQ(ierr);
<a name="l00410"></a>00410   ierr = MatAssemblyEnd(AHexchonly,MAT_FINAL_ASSEMBLY);CHKERRQ(ierr);
<a name="l00411"></a>00411   ierr = MatDiagonalScale(AHexchonly,vertMomrec3,PETSC_NULL);CHKERRQ(ierr);
<a name="l00412"></a>00412   ierr = <a class="code" href="printmatinfo_8c.html#a8c62a6053be02438e1bf2da1efa06f1f">PrintMatInfoAll</a>(AHexchonly);CHKERRQ(ierr);
<a name="l00413"></a>00413 <span class="preprocessor">#endif</span>
<a name="l00414"></a>00414 <span class="preprocessor"></span>
<a name="l00415"></a>00415   ierr = VecDestroy(vertMomrec3);CHKERRQ(ierr);
<a name="l00416"></a>00416 
<a name="l00417"></a>00417   <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00418"></a>00418 }
<a name="l00419"></a>00419 
<a name="l00420"></a>00420 
<a name="l00421"></a><a class="code" href="hexch__ani_8c.html#ab3c152ad4a30f46fd55fff971a53d2ae">00421</a> <span class="keywordtype">int</span> <a class="code" href="field_8h.html#ab3c152ad4a30f46fd55fff971a53d2ae">Hexchani</a>(<a class="code" href="structGridData.html">GridData</a> *gdata,Vec VHtotsum)
<a name="l00422"></a>00422 {
<a name="l00423"></a>00423   <a class="code" href="griddata_8h.html#a4e81d68a7df0ff55ea65b46253e07552">MagparFunctionInfoBegin</a>;
<a name="l00424"></a>00424 
<a name="l00425"></a>00425   <span class="keywordflow">if</span> (doinit) {
<a name="l00426"></a>00426     ierr = <a class="code" href="hexch__ani_8c.html#a9db4f6f0ac5776543bcd4f802226942e">Hexchani_Init</a>(gdata);CHKERRQ(ierr);
<a name="l00427"></a>00427     doinit=0;
<a name="l00428"></a>00428   }
<a name="l00429"></a>00429   <span class="keywordflow">if</span> (!fieldon) {
<a name="l00430"></a>00430     <a class="code" href="griddata_8h.html#a3a0efa409c6998ac8e9d7b30da6a8171">MagparFunctionInfoReturn</a>(0);
<a name="l00431"></a>00431   }
<a name="l00432"></a>00432 
<a name="l00433"></a>00433   <span class="comment">/* calculate field */</span>
<a name="l00434"></a>00434   ierr = MatMult(<a class="code" href="hexch__ani_8c.html#a56704064cd6d4568b0172a2747dd3193">Ad2E_dMidMk</a>,gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,gdata-&gt;<a class="code" href="structGridData.html#a17f878ef23cf508f086e5d1958657e3f">VHexchani</a>);CHKERRQ(ierr);
<a name="l00435"></a>00435 
<a name="l00436"></a>00436   ierr = VecAXPY(VHtotsum,1.0,gdata-&gt;<a class="code" href="structGridData.html#a17f878ef23cf508f086e5d1958657e3f">VHexchani</a>);CHKERRQ(ierr);
<a name="l00437"></a>00437 
<a name="l00438"></a>00438 <span class="preprocessor">#ifdef EXCH</span>
<a name="l00439"></a>00439 <span class="preprocessor"></span>  <span class="comment">/* calculate exchange field separately */</span>
<a name="l00440"></a>00440   ierr = MatMult(AHexchonly,gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,gdata-&gt;VHexchonly);CHKERRQ(ierr);
<a name="l00441"></a>00441 <span class="preprocessor">#endif</span>
<a name="l00442"></a>00442 <span class="preprocessor"></span>
<a name="l00443"></a>00443   <a class="code" href="griddata_8h.html#a9a4d090c28602d7ff7ec883fb6f413db">MagparFunctionProfReturn</a>(0);
<a name="l00444"></a>00444 }
<a name="l00445"></a>00445 
<a name="l00446"></a>00446 
<a name="l00447"></a><a class="code" href="hexch__ani_8c.html#a733ba0411bb628270a030775416d902a">00447</a> <span class="keywordtype">int</span> <a class="code" href="field_8h.html#a733ba0411bb628270a030775416d902a">Hexchani_Energy</a>(<a class="code" href="structGridData.html">GridData</a> *gdata,Vec VMom,PetscReal *energy)
<a name="l00448"></a>00448 {
<a name="l00449"></a>00449   PetscReal e;
<a name="l00450"></a>00450 
<a name="l00451"></a>00451   <a class="code" href="griddata_8h.html#a4e81d68a7df0ff55ea65b46253e07552">MagparFunctionInfoBegin</a>;
<a name="l00452"></a>00452 
<a name="l00453"></a>00453   <span class="keywordflow">if</span> (!fieldon) {
<a name="l00454"></a>00454     *energy=0.0;
<a name="l00455"></a>00455     <a class="code" href="griddata_8h.html#a3a0efa409c6998ac8e9d7b30da6a8171">MagparFunctionInfoReturn</a>(0);
<a name="l00456"></a>00456   }
<a name="l00457"></a>00457 
<a name="l00458"></a>00458   <span class="comment">/* calculate exchange+anisotropy energy */</span>
<a name="l00459"></a>00459   ierr = VecDot(VMom,gdata-&gt;<a class="code" href="structGridData.html#a17f878ef23cf508f086e5d1958657e3f">VHexchani</a>,&amp;e);CHKERRQ(ierr);
<a name="l00460"></a>00460   e /= -2.0;
<a name="l00461"></a>00461   e += Eanioffset;
<a name="l00462"></a>00462 
<a name="l00463"></a>00463   *energy=e;
<a name="l00464"></a>00464 
<a name="l00465"></a>00465   <a class="code" href="griddata_8h.html#a9a4d090c28602d7ff7ec883fb6f413db">MagparFunctionProfReturn</a>(0);
<a name="l00466"></a>00466 }
<a name="l00467"></a>00467 
<a name="l00468"></a>00468 
<a name="l00469"></a>00469 <span class="preprocessor">#ifdef EXCH</span>
<a name="l00470"></a>00470 <span class="preprocessor"></span><span class="keywordtype">int</span> Hexchonly_Energy(<a class="code" href="structGridData.html">GridData</a> *gdata,Vec VMom,PetscReal *energy)
<a name="l00471"></a>00471 {
<a name="l00472"></a>00472   PetscReal e;
<a name="l00473"></a>00473 
<a name="l00474"></a>00474   <a class="code" href="griddata_8h.html#a4e81d68a7df0ff55ea65b46253e07552">MagparFunctionInfoBegin</a>;
<a name="l00475"></a>00475 
<a name="l00476"></a>00476   <span class="keywordflow">if</span> (!fieldon) {
<a name="l00477"></a>00477     *energy=0.0;
<a name="l00478"></a>00478     <a class="code" href="griddata_8h.html#a3a0efa409c6998ac8e9d7b30da6a8171">MagparFunctionInfoReturn</a>(0);
<a name="l00479"></a>00479   }
<a name="l00480"></a>00480 
<a name="l00481"></a>00481   <span class="comment">/* calculate exchange energy */</span>
<a name="l00482"></a>00482   ierr = VecDot(VMom,gdata-&gt;VHexchonly,&amp;e);CHKERRQ(ierr);
<a name="l00483"></a>00483   e /= -2.0;
<a name="l00484"></a>00484 
<a name="l00485"></a>00485   *energy=e;
<a name="l00486"></a>00486 
<a name="l00487"></a>00487   <a class="code" href="griddata_8h.html#a9a4d090c28602d7ff7ec883fb6f413db">MagparFunctionProfReturn</a>(0);
<a name="l00488"></a>00488 }
<a name="l00489"></a>00489 <span class="preprocessor">#endif</span>
<a name="l00490"></a>00490 <span class="preprocessor"></span>
</pre></div></div>
  <hr>
  <address>
    magpar - Parallel Finite Element Micromagnetics Package<br>
    Copyright (C) 2002-2010 Werner Scholz
  </address>
  </body>
</html>

